--
-- HelperNameFrame
-- V1.0.0.0
--
-- @author apuehri
-- Thanks to sfcmod for the inspiration, and code elements 
-- @date 16/12/2021
--
-- Copyright (C) apuehri
-- V1.0.0.0 ..... LS22 first implementation

haGuiHelperNameFrame = {};
local haGuiHelperNameFrame_mt = Class(haGuiHelperNameFrame, TabbedMenuFrameElement);

haGuiHelperNameFrame.CONTROLS = {
	'guiNameHelperM1',
	'guiNameHelperM2',
	'guiNameHelperM3',
	'guiNameHelperM4',
	'guiNameHelperM5',
	'guiNameHelperM6',
	'guiNameHelperM7',
	'guiNameHelperM8',
	'guiNameHelperM9',
	'guiNameHelperM10',
	'guiNameHelperW1',
	'guiNameHelperW2',
	'guiNameHelperW3',
	'guiNameHelperW4',
	'guiNameHelperW5',
	'guiNameHelperW6',
	'guiNameHelperW7',
	'guiNameHelperW8',
	'guiNameHelperW9',
	'guiNameHelperW10',

	'frameHeader',
    'boxLayout'	
}

function haGuiHelperNameFrame:new(i18n)
    local self = TabbedMenuFrameElement.new(nil, haGuiHelperNameFrame_mt);
	
	self.i18n = i18n;
	
	self:registerControls(haGuiHelperNameFrame.CONTROLS);

    return self;	
end

function haGuiHelperNameFrame:copyAttributes(src)
    haGuiHelperNameFrame:superClass().copyAttributes(self, src)

    self.ui = src.ui
    self.i18n = src.i18n	
end

function haGuiHelperNameFrame:initialize()
    self.backButtonInfo = {inputAction = InputAction.MENU_BACK};		
end

function haGuiHelperNameFrame:onFrameOpen()
    haGuiHelperNameFrame:superClass().onFrameOpen(self);	
	
	-- Header
	self.frameHeader.elements[2]:setText(g_i18n:getText("gui_hat_HelperName"));

	-- Name of Helpers
	self:initLayout();
end

function haGuiHelperNameFrame:initLayout()
	if helperadmin.debug then
		print("--- HelperAdminGui Debug ... haGuiHelperNameFrame:initLayout...");
	end;
	-- Name of Helpers
	-- Man
	self.guiNameHelperM1.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM1"));
	self.guiNameHelperM2.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM2"));
	self.guiNameHelperM3.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM3"));
	self.guiNameHelperM4.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM4"));
	self.guiNameHelperM5.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM5"));
	self.guiNameHelperM6.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM6"));
	self.guiNameHelperM7.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM7"));
	self.guiNameHelperM8.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM8"));
	self.guiNameHelperM9.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM9"));
	self.guiNameHelperM10.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperM10"));
	-- Woman
	self.guiNameHelperW1.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW1"));
	self.guiNameHelperW2.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW2"));
	self.guiNameHelperW3.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW3"));
	self.guiNameHelperW4.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW4"));
	self.guiNameHelperW5.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW5"));
	self.guiNameHelperW6.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW6"));
	self.guiNameHelperW7.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW7"));
	self.guiNameHelperW8.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW8"));
	self.guiNameHelperW9.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW9"));
	self.guiNameHelperW10.elements[2]:setText(g_i18n:getText("gui_hat_nameHelperW10"));
	
	if (haGui.actGuiNumHelper >= 3) then
		self.guiNameHelperM1.elements[1]:setText(haGui.actGuiNameMHelp[1]);
		self.guiNameHelperM1.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM1"));
		self.guiNameHelperM2.elements[1]:setText(haGui.actGuiNameMHelp[2]);
		self.guiNameHelperM2.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM2"));
		self.guiNameHelperM3.elements[1]:setText(haGui.actGuiNameMHelp[3]);
		self.guiNameHelperM3.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM3"));
		self.guiNameHelperM4.elements[1].visible = false;
		self.guiNameHelperM4.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperM5.elements[1].visible = false;
		self.guiNameHelperM5.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperM6.elements[1].visible = false;
		self.guiNameHelperM6.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperM7.elements[1].visible = false;
		self.guiNameHelperM7.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperM8.elements[1].visible = false;
		self.guiNameHelperM8.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperM9.elements[1].visible = false;
		self.guiNameHelperM9.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperM10.elements[1].visible = false;
		self.guiNameHelperM10.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW1.elements[1]:setText(haGui.actGuiNameWHelp[1]);
		self.guiNameHelperW1.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW1"));
		self.guiNameHelperW2.elements[1]:setText(haGui.actGuiNameWHelp[2]);
		self.guiNameHelperW2.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW2"));
		self.guiNameHelperW3.elements[1]:setText(haGui.actGuiNameWHelp[3]);
		self.guiNameHelperW3.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW3"));
		self.guiNameHelperW4.elements[1].visible = false;
		self.guiNameHelperW4.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW5.elements[1].visible = false;
		self.guiNameHelperW5.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW6.elements[1].visible = false;
		self.guiNameHelperW6.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW7.elements[1].visible = false;
		self.guiNameHelperW7.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW8.elements[1].visible = false;
		self.guiNameHelperW8.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW9.elements[1].visible = false;
		self.guiNameHelperW9.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
		self.guiNameHelperW10.elements[1].visible = false;
		self.guiNameHelperW10.elements[3]:setText(g_i18n:getText("gui_hat_HelperNotInUseToolTip"));
	end;
	if (haGui.actGuiNumHelper >= 4) then	
		self.guiNameHelperM4.elements[1]:setText(haGui.actGuiNameMHelp[4]);
		self.guiNameHelperM4.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM4"));
		self.guiNameHelperM4.elements[1].visible = true;
		self.guiNameHelperW4.elements[1]:setText(haGui.actGuiNameWHelp[4]);
		self.guiNameHelperW4.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW4"));
		self.guiNameHelperW4.elements[1].visible = true;
	end;
	if (haGui.actGuiNumHelper >= 5) then	
		self.guiNameHelperM5.elements[1]:setText(haGui.actGuiNameMHelp[5]);
		self.guiNameHelperM5.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM5"));
		self.guiNameHelperM5.elements[1].visible = true;
		self.guiNameHelperW5.elements[1]:setText(haGui.actGuiNameWHelp[5]);
		self.guiNameHelperW5.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW5"));
		self.guiNameHelperW5.elements[1].visible = true;		
	end;
	if (haGui.actGuiNumHelper >= 6) then				
		self.guiNameHelperM6.elements[1]:setText(haGui.actGuiNameMHelp[6]);
		self.guiNameHelperM6.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM6"));
		self.guiNameHelperM6.elements[1].visible = true;
		self.guiNameHelperW6.elements[1]:setText(haGui.actGuiNameWHelp[6]);
		self.guiNameHelperW6.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW6"));
		self.guiNameHelperW6.elements[1].visible = true;
	end;
	if (haGui.actGuiNumHelper >= 7) then			
		self.guiNameHelperM7.elements[1]:setText(haGui.actGuiNameMHelp[7]);
		self.guiNameHelperM7.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM7"));
		self.guiNameHelperM7.elements[1].visible = true;
		self.guiNameHelperW7.elements[1]:setText(haGui.actGuiNameWHelp[7]);
		self.guiNameHelperW7.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW7"));
		self.guiNameHelperW7.elements[1].visible = true;
	end;
	if (haGui.actGuiNumHelper >= 8) then				
		self.guiNameHelperM8.elements[1]:setText(haGui.actGuiNameMHelp[8]);
		self.guiNameHelperM8.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM8"));
		self.guiNameHelperM8.elements[1].visible = true;
		self.guiNameHelperW8.elements[1]:setText(haGui.actGuiNameWHelp[8]);
		self.guiNameHelperW8.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW8"));
		self.guiNameHelperW8.elements[1].visible = true;
	end;
	if (haGui.actGuiNumHelper >= 9) then				
		self.guiNameHelperM9.elements[1]:setText(haGui.actGuiNameMHelp[9]);
		self.guiNameHelperM9.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM9"));
		self.guiNameHelperM9.elements[1].visible = true;
		self.guiNameHelperW9.elements[1]:setText(haGui.actGuiNameWHelp[9]);
		self.guiNameHelperW9.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW9"));
		self.guiNameHelperW9.elements[1].visible = true;
	end;
	if (haGui.actGuiNumHelper == 10) then				
		self.guiNameHelperM10.elements[1]:setText(haGui.actGuiNameMHelp[10]);
		self.guiNameHelperM10.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperM10"));
		self.guiNameHelperM10.elements[1].visible = true;
		self.guiNameHelperW10.elements[1]:setText(haGui.actGuiNameWHelp[10]);
		self.guiNameHelperW10.elements[3]:setText(g_i18n:getText("gui_hat_nameHelperW10"));
		self.guiNameHelperW10.elements[1].visible = true;
	end;

	if FocusManager:getFocusedElement() == nil then
		self:setSoundSuppressed(true)
		FocusManager:setFocus(self.boxLayout)
		self:setSoundSuppressed(false)
	end
	
end


function haGuiHelperNameFrame:onEnterPresHeM1()
	haGui.actGuiNameMHelp[1] = self.guiNameHelperM1.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM2()
	haGui.actGuiNameMHelp[2] = self.guiNameHelperM2.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM3()
	haGui.actGuiNameMHelp[3] = self.guiNameHelperM3.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM4()
	haGui.actGuiNameMHelp[4] = self.guiNameHelperM4.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM5()
	haGui.actGuiNameMHelp[5] = self.guiNameHelperM5.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM6()
	haGui.actGuiNameMHelp[6] = self.guiNameHelperM6.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM7()
	haGui.actGuiNameMHelp[7] = self.guiNameHelperM7.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM8()
	haGui.actGuiNameMHelp[8] = self.guiNameHelperM8.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM9()
	haGui.actGuiNameMHelp[9] = self.guiNameHelperM9.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeM10()
	haGui.actGuiNameMHelp[10] = self.guiNameHelperM10.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW1()
	haGui.actGuiNameWHelp[1] = self.guiNameHelperW1.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW2()
	haGui.actGuiNameWHelp[2] = self.guiNameHelperW2.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW3()
	haGui.actGuiNameWHelp[3] = self.guiNameHelperW3.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW4()
	haGui.actGuiNameWHelp[4] = self.guiNameHelperW4.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW5()
	haGui.actGuiNameWHelp[5] = self.guiNameHelperW5.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW6()
	haGui.actGuiNameWHelp[6] = self.guiNameHelperW6.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW7()
	haGui.actGuiNameWHelp[7] = self.guiNameHelperW7.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW8()
	haGui.actGuiNameWHelp[8] = self.guiNameHelperW8.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW9()
	haGui.actGuiNameWHelp[9] = self.guiNameHelperW9.elements[1]:getText();
end;

function haGuiHelperNameFrame:onEnterPresHeW10()
	haGui.actGuiNameWHelp[10] = self.guiNameHelperW10.elements[1]:getText();
end;