--
-- HelperAdminTools
-- V1.0.0.0
--
-- @author apuehri
-- @date 21/12/2021
--
-- Copyright (C) apuehri|LS-Modcompany
-- V1.0.0.0 ..... LS22 first implementation

helperAdminTools = {};
helperAdminTools.debug = helperadmin.debug;

function helperAdminTools:changeAIJob()
	helperAdminTools.aiJobGiantsPrice = AIJob:getPricePerMs();
	helperAdminTools.aiJobConveyorGiantsPrice = AIJobConveyor:getPricePerMs();
	helperAdminTools.aiJobFieldWorkGiantsPrice = AIJobFieldWork:getPricePerMs();
	
	if helperAdminTools.debug then
		print("--- HelperAdmin Debug ... helperAdminTools:changeAIJob(helperAdminTools.aiJobGiantsPrice = "..tostring(helperAdminTools.aiJobGiantsPrice)..")");
		print("--- HelperAdmin Debug ... helperAdminTools:changeAIJob(helperAdminTools.aiJobConveyorGiantsPrice = "..tostring(helperAdminTools.aiJobConveyorGiantsPrice)..")");	
		print("--- HelperAdmin Debug ... helperAdminTools:changeAIJob(helperAdminTools.aiJobFieldWorkGiantsPrice = "..tostring(helperAdminTools.aiJobFieldWorkGiantsPrice)..")");	
	end;
	
	if helperAdminTools.aiJobGiantsPrice ~= nil then
		AIJob.getPricePerMs = Utils.overwrittenFunction(AIJob.getPricePerMs, helperAdminTools.aiJobPricePerMs);
	end;

	if helperAdminTools.aiJobConveyorGiantsPrice ~= nil then
		AIJobConveyor.getPricePerMs = Utils.overwrittenFunction(AIJobConveyor.getPricePerMs, helperAdminTools.aiJobConveyorPricePerMs);
	end;

	if helperAdminTools.aiJobFieldWorkGiantsPrice ~= nil then
		AIJobFieldWork.getPricePerMs = Utils.overwrittenFunction(AIJobFieldWork.getPricePerMs, helperAdminTools.aiJobFieldWorkPricePerMs);
	end;
	
	if helperAdminTools.debug then
		helperAdminTools.aiJobNewPrice = AIJob:getPricePerMs();
		helperAdminTools.aiJobConveyorNewPrice = AIJobConveyor:getPricePerMs();
		helperAdminTools.aiJobFieldWorkNewPrice = AIJobFieldWork:getPricePerMs();	
		print("--- HelperAdmin Debug ... helperAdminTools:changeAIJob(helperAdminTools.aiJobNewPrice = "..tostring(helperAdminTools.aiJobNewPrice)..")");
		print("--- HelperAdmin Debug ... helperAdminTools:changeAIJob(helperAdminTools.aiJobConveyorNewPrice = "..tostring(helperAdminTools.aiJobConveyorNewPrice)..")");
		print("--- HelperAdmin Debug ... helperAdminTools:changeAIJob(helperAdminTools.aiJobFieldWorkNewPrice = "..tostring(helperAdminTools.aiJobFieldWorkNewPrice)..")");
	end;	
end;

function helperAdminTools:aiJobPricePerMs()
	local GiantsPrice = helperAdminTools.aiJobGiantsPrice;
	local PricePerMS = 0; 
	local overtimeFact1 = Utils.getNoNil(helperadmin.overtimeFact1, 1.8);
	local overtimeFact2 = Utils.getNoNil(helperadmin.overtimeFact2, 3.4);
	local retPrice = nil;	
	
	PricePerMS = helperadmin.pricePerHour / 60 / 60 / 1000;
	
	if (math.abs(g_currentMission.environment.currentHour) >= 18) and (math.abs(g_currentMission.environment.currentHour) <= 21) then
		PricePerMS = overtimeFact1 * helperadmin.pricePerHour / 60 / 60 / 1000;
	end;
	if ((math.abs(g_currentMission.environment.currentHour) >= 0) and (math.abs(g_currentMission.environment.currentHour) <= 5)) or ((math.abs(g_currentMission.environment.currentHour) >= 22) and (math.abs(g_currentMission.environment.currentHour) <= 23)) then
		PricePerMS = overtimeFact2 * helperadmin.pricePerHour / 60 / 60 / 1000;
	end;
	retPrice= PricePerMS;

	if retPrice ~= nil then
		return retPrice
	else
		return GiantsPrice
	end;
end;

function helperAdminTools:aiJobConveyorPricePerMs()
	local GiantsPrice = helperAdminTools.aiJobConveyorGiantsPrice;
	local PricePerMS = 0;
	local overtimeFact1 = Utils.getNoNil(helperadmin.overtimeFact1, 1.8);
	local overtimeFact2 = Utils.getNoNil(helperadmin.overtimeFact2, 3.4);
	local retPrice = nil;
	
	PricePerMS = helperadmin.pricePerHour / 60 / 60 / 1000 / 3;
	
	if (math.abs(g_currentMission.environment.currentHour) >= 18) and (math.abs(g_currentMission.environment.currentHour) <= 21) then
		PricePerMS = overtimeFact1 * helperadmin.pricePerHour / 60 / 60 / 1000 / 3;
	end;
	if ((math.abs(g_currentMission.environment.currentHour) >= 0) and (math.abs(g_currentMission.environment.currentHour) <= 5)) or ((math.abs(g_currentMission.environment.currentHour) >= 22) and (math.abs(g_currentMission.environment.currentHour) <= 23)) then
		PricePerMS = overtimeFact2 * helperadmin.pricePerHour / 60 / 60 / 1000 / 3;
	end;
	retPrice= PricePerMS;

	if retPrice ~= nil then
		return retPrice
	else
		return GiantsPrice
	end;	
end;

function helperAdminTools:aiJobFieldWorkPricePerMs()
	local GiantsPrice = helperAdminTools.aiJobFieldWorkGiantsPrice;
	local PricePerMS = 0;
	local overtimeFact1 = Utils.getNoNil(helperadmin.overtimeFact1, 1.8);
	local overtimeFact2 = Utils.getNoNil(helperadmin.overtimeFact2, 3.4);
	local retPrice = nil;
	
	PricePerMS = helperadmin.pricePerHour / 60 / 60 / 1000;
	
	if (math.abs(g_currentMission.environment.currentHour) >= 18) and (math.abs(g_currentMission.environment.currentHour) <= 21) then
		PricePerMS = overtimeFact1 * helperadmin.pricePerHour / 60 / 60 / 1000;
	end;
	if ((math.abs(g_currentMission.environment.currentHour) >= 0) and (math.abs(g_currentMission.environment.currentHour) <= 5)) or ((math.abs(g_currentMission.environment.currentHour) >= 22) and (math.abs(g_currentMission.environment.currentHour) <= 23)) then
		PricePerMS = overtimeFact2 * helperadmin.pricePerHour / 60 / 60 / 1000;
	end;
	retPrice= PricePerMS;

	if retPrice ~= nil then
		return retPrice
	else
		return GiantsPrice
	end;	
end;

function helperAdminTools:rideHorses()
	if g_currentMission.player ~= nil then
		local amount = tonumber(25 + (g_currentMission.missionInfo.difficulty * 5));
		local totalAmount = 0;
		
		if helperadmin.rideHorses then
			if (math.abs(g_currentMission.environment.currentHour) == 10) or (math.abs(g_currentMission.environment.currentHour) == 16) then		
				for _, clusterHusbandries in pairs(g_currentMission.husbandrySystem.clusterHusbandries) do
					if clusterHusbandries.animalTypeName == "HORSE" then			
						for _, animal in pairs(clusterHusbandries.animalIdToCluster) do
							-- if helperadmin.debug then
								-- print("--- HelperAdmin Debug ... helperAdminTools:rideHorses(clusterHusbandries.animalIdToCluster)");
								-- DebugUtil.printTableRecursively(clusterHusbandries.animalIdToCluster,"----",0,1)
							-- end;
							for _, animalIdToCluster in pairs(animal.clusterSystem:getClusters()) do							
								if animalIdToCluster ~= nil then							
									if (math.abs(g_currentMission.environment.currentHour) == 10) and (animalIdToCluster.riding < 50) then
										animalIdToCluster:setRiding(50);
										totalAmount = totalAmount + amount;
									else
										if (math.abs(g_currentMission.environment.currentHour) == 16) then
											if (animalIdToCluster.riding < 50) then
												animalIdToCluster:setRiding(50);
												animalIdToCluster:changeDirt(-animalIdToCluster.dirt);
												totalAmount = totalAmount + amount;
											else
												if (animalIdToCluster.riding >= 50) and (animalIdToCluster.riding < 100) then
													animalIdToCluster:setRiding(100);
													animalIdToCluster:changeDirt(-animalIdToCluster.dirt);
													totalAmount = totalAmount + amount;
												end;
											end;
										end;
									end;
								end;
							end;
						end;
					end;
				end;
				g_currentMission:addMoney(-totalAmount, g_currentMission.player.farmId, MoneyType.AI);
				
				if helperAdminTools.debug then
					print("--- HelperAdmin Debug ... helperAdminTools:rideHorses(riding Done(totalAmount)= "..tostring(totalAmount)..")");
				end;			
			end;
		end;
	end;
end;